      subroutine SLhpf_cgridinf(A, descA, P, Q, pmap, info0)
!
!  -- Layer 1 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      USE HPF_LIBRARY
      include 'misc.h'
      include 'pblas.h'
      complex(SP), intent(in) :: A(:,:)
      integer, dimension(DLEN_,NUMBER_OF_PROCESSORS()),                 &
     &         intent(inout) :: descA
!HPF$ DISTRIBUTE (*,block) :: descA
      integer, intent(out) :: P, Q, pmap(:)
      integer, optional, intent(out) :: info0
!HPF$ INHERIT A, pmap

      integer :: m, n, mb, nb, info, prank, pshape(2)

      INTERFACE
      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_get_gridshape(P, Q, maxP, maxQ)
         integer, intent(out) :: P, Q
         integer, optional, intent(in) :: maxP, maxQ
      end subroutine SLhpf_get_gridshape
      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_cget_procmap(A, desca, P, Q, pmap)
         include 'misc.h'
         complex(SP), intent(in) :: A(:,:)
         integer, intent(inout) :: descA(:,:)
         integer, intent(out) :: P, Q, pmap(:)
!HPF$    DISTRIBUTE(*,block) :: descA
!HPF$    INHERIT A, pmap
      end subroutine SLhpf_cget_procmap
      END INTERFACE

      info = 0
      call HPF_DISTRIBUTION(A, PROCESSORS_RANK=prank)
      if (prank .gt. 2) then
         info = -CTXT_
      else
         call SLhpf_cget_procmap(A, descA, P, Q, pmap)
      end if
!
!     If we have an illegal grid, find good P and Q to use during redistribution
!
      if (info .ne. 0) call SLhpf_get_gridshape(P, Q)
      if (present(info0)) info0 = info

      return
      end

