      extrinsic(hpf_local)                                              &
     &subroutine SLhpf_get_gridshape(P, Q, maxP, maxQ)
!
!  -- Layer 2 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
      integer, intent(out) :: P, Q
      integer, optional, intent(in) :: maxP, maxQ

      integer :: Np, i

      Np = NUMBER_OF_PROCESSORS()
      P = 2
      do
         Q = Np / P
         if ( (P .gt. Q) .or. (P * Q .ne. Np) ) exit
         P = P * 2
      end do
      P = P / 2
      Q = Np / P
      if ( present(maxP) ) then
         i = max(maxP, 1)
         do while (P .gt. i)
            P = P / 2
            Q = Q * 2
         end do
      else if ( present(maxQ) ) then
         i = max(maxQ, 1)
         do while (Q .gt. i)
            Q = Q / 2
            P = P * 2
         end do
      end if

      return
      end
