      subroutine SLhpf_get_hpf2sys_map(h2smap, Np0, Iam0)
!
!  -- Layer 3 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
!
!     This function maps HPF IDs to system IDs
!
      integer Np0, Iam0
      integer h2smap(*)
!
      integer blacs_pnum
      external SLhpf_pvmblacs_setup, blacs_abort, blacs_get,            &
     &         blacs_gridexit, blacs_gridinfo, blacs_gridinit,          &
     &         blacs_pinfo, blacs_pnum, igsum2d

      integer gctxt, Np, Iam, i, j
!
      call blacs_pinfo(iam, i)
      if (i .lt. 1) call SLhpf_pvmblacs_setup(Np0, h2smap)
      call blacs_get(-1, 0, gctxt)
      call blacs_gridinit(gctxt, 'row', 1, Np0)
      call blacs_gridinfo(gctxt, i, Np, j, Iam)
      if (i.eq.-1) then
         print*,'Not all processes calling are in HPF machine!'
         call blacs_abort(gctxt,-1)
      end if

      do 10 i = 1, Np
         h2smap(i) = 0
   10 continue
      h2smap(Iam0+1) = blacs_pnum(gctxt, 0, Iam)
      call igsum2d(gctxt, 'a', ' ', Np, 1, h2smap, Np, -1, -1)
      call blacs_gridexit(gctxt)

      return
      end
