      subroutine SLhpf_pvmblacs_setup(Np, TIDS)
!
!  -- Layer 3 ScaLAPACK HPF wrapper routine, (version 1.1) --
!     September 1, 1998
!     Written by R. Clint Whaley, University of Tennessee, Knoxville
!
!
!     This routine sets up the PVM machine for the BLACS if it has already
!     been spawned
!
      integer Np
      integer TIDS(Np)
      character*20 gname
      parameter ( gname='SLhpfpvmgrid' )
      integer mytid, i
!
!     Enroll in PVM machine, if necessary
!
      call pvmfmytid(mytid)
      if (mytid .lt. 0) then
         print*,'Must start PVM before calling ScaLAPACK routines'
         call pvmfexit(mytid)
         stop
      end if

      call pvmfjoingroup(gname, i)
      call pvmfbarrier(gname, Np, i)
!
!     Fill in tid list
!
      do i = 0, Np-1
         call pvmfgettid(gname, i, tids(1+i))
      end do
      call setpvmtids(Np, tids)

      call pvmfbarrier(gname, Np, i)
      call pvmflvgroup(gname, i)

      RETURN
      END


